/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CampaignStrategyChannel type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignStrategyChannel{}

// CampaignStrategyChannel struct for CampaignStrategyChannel
type CampaignStrategyChannel struct {
	TagPreference *string `json:"tag_preference,omitempty"`
	UsagePreference *string `json:"usage_preference,omitempty"`
}

// NewCampaignStrategyChannel instantiates a new CampaignStrategyChannel object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignStrategyChannel() *CampaignStrategyChannel {
	this := CampaignStrategyChannel{}
	return &this
}

// NewCampaignStrategyChannelWithDefaults instantiates a new CampaignStrategyChannel object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignStrategyChannelWithDefaults() *CampaignStrategyChannel {
	this := CampaignStrategyChannel{}
	return &this
}

// GetTagPreference returns the TagPreference field value if set, zero value otherwise.
func (o *CampaignStrategyChannel) GetTagPreference() string {
	if o == nil || IsNil(o.TagPreference) {
		var ret string
		return ret
	}
	return *o.TagPreference
}

// GetTagPreferenceOk returns a tuple with the TagPreference field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignStrategyChannel) GetTagPreferenceOk() (*string, bool) {
	if o == nil || IsNil(o.TagPreference) {
		return nil, false
	}
	return o.TagPreference, true
}

// HasTagPreference returns a boolean if a field has been set.
func (o *CampaignStrategyChannel) HasTagPreference() bool {
	if o != nil && !IsNil(o.TagPreference) {
		return true
	}

	return false
}

// SetTagPreference gets a reference to the given string and assigns it to the TagPreference field.
func (o *CampaignStrategyChannel) SetTagPreference(v string) {
	o.TagPreference = &v
}

// GetUsagePreference returns the UsagePreference field value if set, zero value otherwise.
func (o *CampaignStrategyChannel) GetUsagePreference() string {
	if o == nil || IsNil(o.UsagePreference) {
		var ret string
		return ret
	}
	return *o.UsagePreference
}

// GetUsagePreferenceOk returns a tuple with the UsagePreference field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignStrategyChannel) GetUsagePreferenceOk() (*string, bool) {
	if o == nil || IsNil(o.UsagePreference) {
		return nil, false
	}
	return o.UsagePreference, true
}

// HasUsagePreference returns a boolean if a field has been set.
func (o *CampaignStrategyChannel) HasUsagePreference() bool {
	if o != nil && !IsNil(o.UsagePreference) {
		return true
	}

	return false
}

// SetUsagePreference gets a reference to the given string and assigns it to the UsagePreference field.
func (o *CampaignStrategyChannel) SetUsagePreference(v string) {
	o.UsagePreference = &v
}

func (o CampaignStrategyChannel) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignStrategyChannel) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TagPreference) {
		toSerialize["tag_preference"] = o.TagPreference
	}
	if !IsNil(o.UsagePreference) {
		toSerialize["usage_preference"] = o.UsagePreference
	}
	return toSerialize, nil
}

type NullableCampaignStrategyChannel struct {
	value *CampaignStrategyChannel
	isSet bool
}

func (v NullableCampaignStrategyChannel) Get() *CampaignStrategyChannel {
	return v.value
}

func (v *NullableCampaignStrategyChannel) Set(val *CampaignStrategyChannel) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignStrategyChannel) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignStrategyChannel) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignStrategyChannel(val *CampaignStrategyChannel) *NullableCampaignStrategyChannel {
	return &NullableCampaignStrategyChannel{value: val, isSet: true}
}

func (v NullableCampaignStrategyChannel) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignStrategyChannel) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


